var PadInstrument = new PadMode();

PadInstrument.handleMIDI = function (data1, data2)
{
	if (data2 > 0) 
	{
		PadNotes.sendRawMidiEvent (0x90, data1, data2);
	}
	else
	{
		PadNotes.sendRawMidiEvent (0x80, data1, data2);		
	}
}

PadInstrument.handleNavKeys = function (data1) 
{
    if (data1 == NAVKeys.LEFT) {
        shifted ? cursorTrack.selectPrevious() : cursorDevice.selectPrevious();
    }
    
    else if (data1 == NAVKeys.RIGHT) {
        shifted ? cursorTrack.selectNext() : cursorDevice.selectNext();
    }
    else if (data1 == NAVKeys.UP) {
        shifted ? cursorDevice.switchToNextPreset() : cursorDevice.nextParameterPage();
        
    }
    else if (data1 == NAVKeys.DOWN) {
        shifted ? cursorDevice.switchToPreviousPreset() : cursorDevice.previousParameterPage() ;
    }
}

PadInstrument.init = function()
{
    if (displayHelpText) {
        host.showPopupNotification("Pads: Instrument/Drum Rack Mode");
    }

    usingDrumMachine ? PadInstrument.lightPadsForDrumRack(CursorTrackColor) : lightAllPads(CursorTrackColor,"Off");
    PadNotes.setKeyTranslationTable(PadMIDITable.ON);    
}

PadInstrument.cursorTrackColorObs = function(red,green,blue) {
    PadMode.prototype.cursorTrackColorObs(red,green,blue);

    if (usingDrumMachine) {
        PadInstrument.lightPadsForDrumRack (CursorTrackColor);
    }
    
    else {
        lightAllPads(CursorTrackColor,"Off");
    }
}


PadInstrument.cursorTrackInstrumentNameObs = function (track, text)
{
    PadMode.prototype.cursorTrackInstrumentNameObs(track,text);
    usingDrumMachine ? PadInstrument.lightPadsForDrumRack(CursorTrackColor) : lightAllPads(CursorTrackColor,"Off");
}

PadInstrument.lightPadsForDrumRack = function(color) {
    for (var x = 36; x < 100; x++)
    {
        if (drumKeys[x] == false)
        {
            lightPad(padColors['Off'],x - 36,"Off");
        }
        else
        {
            lightPad(color, x - 36, "Off");
        }
    }
}

PadInstrument.cursorTrackpitchObs = function(key,name)
{
    PadMode.prototype.cursorTrackpitchObs(key,name);
    PadInstrument.lightPadsForDrumRack(CursorTrackColor)
}